@ECHO OFF

rem db2cat fix and other post-11.5.4 upgrade tasks
rem StarQuest Ventures, Inc.
rem 10/22/20

rem Customize and run this from an elevated DB2 command window running as a user
rem  with adequate operating system and database authority

rem See ./readme.txt for details

rem FIX FOR:
rem https://www.ibm.com/support/pages/node/6246049
rem After successfully upgrading or updating to Db2 v11.5.4, it is possible to see SQL901 errors and engine crashes

rem Run this on all SQDR (SQDRC & SQDRPn) databases after DB2 has been updated to 11.5.4 
rem i.e. any databases that derive from our templates
rem The numbers should match when you run db2cat -d -Y a second time



set DB2DIR=C:\Program Files\IBM\SQLLIB
set DB2=%DB2DIR%\bin\db2
set DB2CLP=DB20FADE
set DB2INSTANCE=DB2
set DB2CAT=%DB2DIR%\bin\db2cat.exe

set LOG=db2cat.log

rem Replace db2cat.exe & .bnd only if they have not already been replaced

@ECHO ON

IF NOT EXIST "%DB2DIR%\bin\db2cat-orig.exe" (
  ren "%DB2DIR%\bin\db2cat.exe"  "db2cat-orig.exe" 
  ren "%DB2DIR%\bnd\db2cat.bnd"  "db2cat-orig.bnd" 
  copy db2cat.exe "%DB2DIR%\bin"
  copy db2cat.bnd "%DB2DIR%\bnd"

)
@ECHO OFF

rem Pausing here to make sure there were no security errors in replacing db2cat.exe and .bnd
pause

rem Make sure that there are no active database connections

rem CUSTOMIZE the database list
rem See readme for a batch file to generate a list of databases, and replace the list of databases below
rem CUSTOMIZE the steps to perform

for %%x in ( 
 SQDRC ^
 SQDRP0 ^
 ) do (

echo %%x
echo %%x >> %LOG%
"%DB2%" deactivate db %%x >> %LOG% 2>&1

echo DB2 UPGRADE DB %%x
"%DB2%" upgrade db %%x >> %LOG% 2>&1

rem run DB2CAT twice - the numbers should match on the 2nd run
"%DB2CAT%" -d %%x -Y >> %LOG% 2>&1
"%DB2CAT%" -d %%x -Y >> %LOG% 2>&1

db2updv115 -d %%x >> %LOG% 2>&1

"%DB2%" update db cfg for %%x using CATALOGCACHE_SZ 1000 >> %LOG% 2>&1
"%DB2%" update db cfg for %%x using LOGFILSIZ 8192 >> %LOG% 2>&1

)

rem CUSTOMIZE
rem Optional: restore the original versions of db2cat.exe and .bnd

rem del "%DB2DIR%\bin\db2cat.exe"
rem del "%DB2DIR%\bnd\db2cat.bnd"
rem ren "%DB2DIR%\bin\db2cat-orig.exe"  "db2cat.exe" 
rem ren "%DB2DIR%\bnd\db2cat-orig.bnd"  "db2cat.bnd" 
